// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once
#include "ISCW_UObject.h"

#include <memory>
#include <string>

using std::shared_ptr;
using std::wstring;

namespace Sourcify
{	
	class ISCW_UGeneralProjectSettings : public virtual ISCW_UObject
	{
	public:
		virtual ~ISCW_UGeneralProjectSettings() = default;
		
		virtual wstring GetCopyrightNotice() const = 0;

		virtual shared_ptr<ISCW_UGeneralProjectSettings> ToUGeneralProjectSettingsPtr() = 0;
		virtual shared_ptr<const ISCW_UGeneralProjectSettings> ToUGeneralProjectSettingsPtr() const = 0;
	};

	using ISCW_UGeneralProjectSettingsConstPtr = shared_ptr<const ISCW_UGeneralProjectSettings>;
	using ISCW_UGeneralProjectSettingsPtr = shared_ptr<ISCW_UGeneralProjectSettings>;
} // namespace Sourcify